<?php
// Thanks: Don| Athlon, [UMF] pikku-w, [UMF] vompatti, mikey, TDO| mucho

require_once('gettext.inc');

Aseco::registerEvent('onStartup', 'relay_startup');
Aseco::registerEvent('onPlayerConnect', 'relay_connect');
Aseco::registerEvent('onEverySecond', 'relay_counters');
Aseco::registerEvent("onCheckpoint", "relay_checkPoint");
Aseco::registerEvent('onSync', 'relay_onSync');
Aseco::registerEvent('onPlayerFinish', 'relay_PlayerFinish');
Aseco::registerEvent('onNewChallenge', 'relay_newtrack');
Aseco::registerEvent('onBeginRound', 'relay_begin');
Aseco::registerEvent('onPlayerDisconnect', 'relay_disconnect');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'event_relayrace');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'event_trackselect');
Aseco::registerEvent('onMenuLoaded', 'relay_initMenu');

Aseco::addChatCommand('relay', 'Relayrace sub commands, see /relay help');
global $relay;

function relay_initMenu($aseco, $menu) {
	$menu->addEntry('admingamemode', '', false, 'RelayRace', 'relay');
	$menu->addEntry('relay', '', true, 'Start', 'relay_on', '/relay on', '', '', '');
	$menu->addEntry('relay', '', true, 'Stop', 'relay_off', '/relay off', '', '', '');
}


function relay_counters($aseco, $command) {
global $relay;
$relay->counters();
}

function relay_startup($aseco, $command)
   {
   global $relay;

   $relay = new RelayRace();
   $relay->Aseco = $aseco;
   // Debugmode, Debug, debug mode, enable debug
   $relay->debug = 0;
   // 
   $xml_parser = new Examsly();
    if ($settings = $xml_parser->parseXml('relayrace.xml')) {
 	$relay->settings = $settings;
	
	$relay->TeamCount = $settings['SETTINGS']['GAME'][0]['TEAMS'][0];
	if ( $relay->TeamCount > 8) trigger_error('[plugin.relayrace.php] Too many teams defined', E_USER_WARNING);
    
	$relay->TeamMaxPlayers =$settings['SETTINGS']['GAME'][0]['PLAYERS'][0];
	if ( $relay->TeamCount < 1) trigger_error('[plugin.relayrace.php] max players must be greater than 1', E_USER_WARNING);
	
	$relay->Laps =$settings['SETTINGS']['GAME'][0]['DEFAULT_STAGES'][0];
	if ( $relay->TeamCount < 1 ) trigger_error('[plugin.relayrace.php] Default stages must be greater that 1', E_USER_WARNING);
    
	$relay->Points = explode(",",$settings['SETTINGS']['GAME'][0]['POINTS'][0],8); // assign points
	if ( $relay->Points < 8) trigger_error('[plugin.relayrace.php] xml parse error, game->points count needs to be 8', E_USER_WARNING);
	//if ( !empty($wu) && $wu > 3 && $wu < 1 ) trigger_error('[plugin.relayrace.php] Warmup duration problem', E_USER_WARNING);
    $relay->TeamLock['enabled'] = 0;
	if ($settings['SETTINGS']['GAME'][0]['TEAM_LOCKING'][0] == 'true') $relay->TeamLock['enabled'] = 1;
    $relay->skipenv = 0;
	if ($settings['SETTINGS']['GAME'][0]['SKIP_VOTES'][0] == 'true') $relay->skipenv = 1;
    $relay->hideLogo = 0;
	if ($settings['SETTINGS']['GAME'][0]['HIDE_LOGO'][0] == 'true') $relay->hideLogo = 1;
	
   $relay->Counters["selectEnvironment"]["Timeout"]= $settings['SETTINGS']['COUNTERS'][0]['SELECT_ENVIRONMENT'][0];
   $relay->Counters["selectChallenge"]["Timeout"] = $settings['SETTINGS']['COUNTERS'][0]['SELECT_CHALLENGE'][0];
   $relay->Counters["showScoreboard"]["Timeout"] = $settings['SETTINGS']['COUNTERS'][0]['SHOW_SCOREBOARD'][0];
   $relay->Counters['finishTeam']['Timeout'] = $settings['SETTINGS']['COUNTERS'][0]['TEAMFINISH'][0];
   $relay->Counters["showPoints"]["Timeout"] =  $settings['SETTINGS']['COUNTERS'][0]['SHOWPOINTS'][0];    
   
   $relay->TeamNames[0] = $settings['SETTINGS']['TEAMS'][0]['TEAM1'][0];
   $relay->TeamNames[1] = $settings['SETTINGS']['TEAMS'][0]['TEAM2'][0];
   $relay->TeamNames[2] = $settings['SETTINGS']['TEAMS'][0]['TEAM3'][0];
   $relay->TeamNames[3] = $settings['SETTINGS']['TEAMS'][0]['TEAM4'][0];
   $relay->TeamNames[4] = $settings['SETTINGS']['TEAMS'][0]['TEAM5'][0];
   $relay->TeamNames[5] = $settings['SETTINGS']['TEAMS'][0]['TEAM6'][0];
   $relay->TeamNames[6] = $settings['SETTINGS']['TEAMS'][0]['TEAM7'][0];
   $relay->TeamNames[7] = $settings['SETTINGS']['TEAMS'][0]['TEAM8'][0];

   
   } else {
      // could not parse XML file
      trigger_error('[plugin.relayrace.php] Could not read/parse setttings file relayrace.xml!', E_USER_WARNING);
      return false;
   }
   $relay->Counters["selectEnvironment"]["count"] = 0;
   $relay->Counters["showScoreboard"]["count"] =  0;
   $relay->Counters["showScoreboard"]["enabled"] = 0;
   $relay->Counters["finishTeam"]["count"] =  0;
   $relay->Counters["finishTeam"]["enabled"] = 0;
   $relay->Counters["showPoints"]["count"] =  0;
   $relay->Counters["showPoints"]["enabled"] = 0;
   
   $relay->Cache = array();
  
   $relay->startok=0; 
   $relay->compmax = 0;
  	define('PROJECT_DIR', realpath('./'));
	define('LOCALE_DIR', PROJECT_DIR .'/plugins/relayrace/locale');
	define('DEFAULT_LOCALE', 'en_US');

	$locale = $settings['SETTINGS']['GAME'][0]['LOCALE'][0]; // set locale
	T_setlocale(LC_MESSAGES, $locale);
	// Set the text domain as 'messages'
	$domain = 'messages';
	T_bindtextdomain($domain, LOCALE_DIR);
	T_bind_textdomain_codeset($domain, "UTF-8");
	T_textdomain($domain);
	
	if (!locale_emulation()) {
	 trigger_error('[plugin.relayrace.php] Translations cannot be enabled, check relayrace.xml!!', E_USER_WARNING);
	}

} 

function chat_relay($aseco, $command) {
global $relay;
$player = $command['author'];
$login = $player->login;
// split params into arrays & insure optional parameters exist
$arglist = explode(' ', $command['params'], 2);
if (!isset($arglist[1])) $arglist[1] = '';
$command['params'] = explode(' ', preg_replace('/ +/', ' ', $command['params']));
if (!isset($command['params'][1])) $command['params'][1] = '';

if ($command['params'][0] == 'start' || $command['params'][0] == 'on') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
 $wu = (int)$relay->settings['SETTINGS']['GAME'][0]['WU_DURATION'][0];
  $aseco->client->query('SetAllWarmUpDuration', $wu);
 // $aseco->client->query('GetTimeAttackLimit');
  $aseco->client->query('GetAllWarmUpDuration');
  $tlimit=$aseco->client->getResponse();
  
   // if ( $tlimit[NextValue] <= 900000 ) 
  $aseco->client->query('SetTimeAttackLimit',0);
  $aseco->client->query('ChatSendServerMessage', '$f80'.T_("Relay Race mode Enabled"));
  $relay->resetgame();
	$relay->logo_on();
  }
  else $aseco->client->query('ChatSendServerMessageToLogin', '$f00'.T_('For admin only'), $login);    
}

if ($command['params'][0] == 'lock' || $command['params'][0] == 'unlock') {
	if ( $relay->GameState != "selectTeams" ) return;
	
	$team = $relay->getPlayerAttrByLogin($login,"Team");
	$playersInTeam = count($relay->playerSearch("Team",$team));
	
	if ($relay->settings['SETTINGS']['GAME'][0]['TEAM_LOCKING'][0] == 'true' && $playersInTeam == 2) {
		if ($relay->TeamLock[$team] == 1) {
			relay_debug('lock off');
			$relay->TeamLock[$team] = 0;
			$relay->teamSelect();
		} else {
			$relay->TeamLock[$team] = 1;
			$relay->teamSelect();
		}
	}
	 else $aseco->client->query('ChatSendServerMessageToLogin', '$f00'.T_('Locking not available'), $login); 
}
if ($command['params'][0] == 'stop' || $command['params'][0] == 'off') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
    //print 'RelayRace disabled';
    $relay->compmax=0;
    $relay->resetgame();
    $relay->allSpecOff();
    $relay->allSpecFree();
    $relay->resetCounters();
    $relay->MLresetAll();
  	$relay->logo_off();
	$relay->TeamLock = array(); // reset locking
	$relay->Players=array(); // reset teams & team names
	$relay->TeamNames[0] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM1'][0];
	$relay->TeamNames[1] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM2'][0];
   $relay->TeamNames[2] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM3'][0];
   $relay->TeamNames[3] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM4'][0];
   $relay->TeamNames[4] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM5'][0];
   $relay->TeamNames[5] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM6'][0];
   $relay->TeamNames[6] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM7'][0];
   $relay->TeamNames[7] = $relay->settings['SETTINGS']['TEAMS'][0]['TEAM8'][0];
   
    $relay->GameState = 'off';
    $aseco->client->query('ChatSendServerMessage', '$f00'.T_('Relay Race mode disabled')); 
	$TAlimit = (int)$relay->settings['SETTINGS']['GAME'][0]['TA_TIMELIMIT'][0];
    $aseco->client->query('SetAllWarmUpDuration', 0);
	$aseco->client->query('SetTimeAttackLimit',$TAlimit);  // reset timeattack timelimit to normal
	$aseco->client->query('NextChallenge'); // goto next challenge
	
  }
  else $aseco->client->query('ChatSendServerMessageToLogin', '$f00'.T_('For admin only'), $login);     
}

if ($command['params'][0] == 'specoff' || $command['params'][0] == 'unspec') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
    $relay->allSpecOff();
  }
  else $aseco->client->query('ChatSendServerMessageToLogin',  '$f00'.T_('For admin only'), $login);     
}

if ($command['params'][0] == 'spec' || $command['params'][0] == 'specon') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {

  }
  else $aseco->client->query('ChatSendServerMessageToLogin',  '$f00'.T_('For admin only'), $login);     
}

if ($command['params'][0] == 'stages' || $command['params'][0] == 'laps') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
    if ($command['params'][1] != '') {
      $laps = $command['params'][1];
      $relay->Laps = $laps;
      $message = "Relay Stages set to ".$relay->Laps;
      $aseco->client->query('ChatSendServerMessage', $message); 
    } 
  }
  else $aseco->client->query('ChatSendServerMessageToLogin',  '$f00'.T_('For admin only'), $login);    
}

if ($command['params'][0] == 'selectoff' || $command['params'][0] == 'envoff') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
  $relay->skipenv = 1;
  $aseco->client->query('ChatSendServerMessage', '$f00'.T_('Enviro & track selection disabled')); 
  }
  else $aseco->client->query('ChatSendServerMessageToLogin', '$f00'.T_('For admin only'), $login);     
}

if ($command['params'][0] == 'select' || $command['params'][0] == 'env') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
  $relay->skipenv = 0;
  $aseco->client->query('ChatSendServerMessage', '$f00'.T_('Enviro & track selection enabled')); 
  }
  else $aseco->client->query('ChatSendServerMessageToLogin', '$f00'.T_('For admin only'), $login);   
}



if ($command['params'][0] == 'comp') {
  if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
    if ($command['params'][1] != '') {
      $max = $command['params'][1];
      if ($max == 'stop') {
        $relay->compmax = 0;
      } else {
        $relay->compmax = $max;
        $relay->comprnd = 0;
        $relay->teamPoints[0] = 0 ;  
        $relay->teamPoints[1] = 0 ;
        $relay->teamPoints[2] = 0 ;
        $relay->teamPoints[3] = 0 ;
        $relay->teamPoints[4] = 0 ;
        $relay->teamPoints[5] = 0 ;
        $relay->teamPoints[6] = 0 ;
        $relay->teamPoints[7] = 0 ;
        $message = sprintf(T_("Relay Competition set to %d rounds"), $relay->compmax);
        $aseco->client->query('ChatSendServerMessage', $message); 
      }
    } 
    if ($command['params'][1] == '') {
      $aseco->client->query('ChatSendServerMessageToLogin', '$f80'.T_('Set number of rounds, example $fff/relay comp 5'), $login);  
    }    
  }
  else $aseco->client->query('ChatSendServerMessageToLogin', '$f00'.T_('For admin only'), $login);    
}

if ($command['params'][0] == 'name' || $command['params'][0] == 'team') {
	for ($i = 1; $i < count($command['params']); $i++) {
	$newname .= $command['params'][$i]." ";
	}
	if ( $relay->GameState != "selectTeams" ) return;
	$newname = str_replace('"', "'", $newname);
	$team = $relay->getPlayerAttrByLogin($login,"Team");
	if ($team != -1 && $team !== false) {
	$relay->TeamNames[$team] = substr($newname,0,15);
	}
	$relay->teamSelect();
}

	if ($command['params'][0] == 'help') {
		 if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {
		
					$header = T_('Help for relayrace!');
					$help = array();
					$help[] = array('{#server}/relay start');
					$help[] = array('{#black}'.T_('Start relayrace-mode'));
					$help[] = array('{#server}/relay stop');
					$help[] = array('{#black}'.T_('Stops the relayrace-mode'));
					$help[] = array('{#server}/relay stages {#black}$inumber');
					$help[] = array('{#black}'.T_('Sets the count for stages to play'));
					$help[] = array('{#server}/relay comp {#black}$inumber');
					$help[] = array('{#black}'.T_('Starts a competition for a number of rounds'));
					$help[] = array('{#server}/relay select');
					$help[] = array('{#black}'.T_('Enable Track & environment voting for users'));
					$help[] = array('{#server}/relay selectoff');
					$help[] = array('{#black}'.T_('Disable Track & environment voting for users'));
					$help[] = array('{#server}/relay spec');
					$help[] = array('{#black}'.T_('Forces all to spectate'));
					$help[] = array('{#server}/relay specoff');
					$help[] = array('{#black}'.T_('Forces all to track'));
					$help[] = array('{#server}/relay name {#black}$inew team name');
					$help[] = array('{#black}'.T_('Sets the current team name (only during team select)'));
					$help[] = array('{#server}/relay lock & /relay unlock');
					$help[] = array('{#black}'.T_('Locks / unlocks the team (min 2 players)'));

					// display ManiaLink message
					display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.0, 1.0), 'OK');
		  } else {
					$header = T_('Help for relayrace!');
					$help = array();
					$help[] = array('{#server}/relay name {#black}$inew team name');
					$help[] = array('{#black}'.T_('Sets the current team name (only during team select)'));
					$help[] = array('{#server}/relay lock & /relay unlock');
					$help[] = array('{#black}'.T_('Locks / unlocks the team (min 2 players!)'));
					// display ManiaLink message
					display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.0, 1.0), 'OK');
			}
	}
	

}



function relay_onSync($aseco, $command) {
global $relay;
getChallengeList();
$relay->GameState = "off";
}

function relay_newtrack($aseco, $challenge) {
global $relay;

if ( $relay->Counters['selectTeams']['enabled'] == 2 ) {
	$relay->Counters['selectTeams']['enabled'] = 1 ;
	
	$relay->MLresetAll();

foreach( $aseco->server->players->player_list as $pl) {
	$team = $relay->getPlayerAttrByLogin($pl->login,"Team");
	if ($team === false) {
		$relay->showJoinTeam($pl->login);
	}
}

  $relay->teamSelect();   // do team select
  }
}

function relay_begin($aseco) {
global $relay;
$relay->startok=1;
	
	if ($relay->GameState == 'raceReady') {
		$relay->checkOnlinePlayers();
		foreach ($relay->Players as $data) {
				if ($data['Team'] == -1) { 
					$online['spec']++;
				} else {
					$online['players']++;
				}
			}
		$message = 'debug: raceready... spec:'.$online['spec']." players:".count($relay->Players);
		relay_debug($message);	
		
		  if ( $online['spec'] == count($relay->Players) || count($relay->Players) == 0) {
				relay_debug('resetGame');
				$relay->resetgame();
				} 
				else { 
				relay_debug('startRace');
				$relay->startRace();
			}
	}
}


function relay_checkPoint($aseco, $param) {
global $relay;
	$login = $param[1];
	$time = $param[2];
	if ($relay->GameState != "race") return;
	
	$team = $relay->getPlayerAttrByLogin($login, "Team");
	$relay->TeamTime[$team]['tempCP']++;
	
		$team = $relay->getPlayerAttrByLogin($login, "Team");
		$starttime = $relay->getPlayerAttrByLogin($login, "inStamp");
		$output = 0;
		
		$relay->TeamTime[$team]['team'] = $team;
		
		if ($starttime) {
			$time = $relay->getTime();
			$output = abs( $starttime - $time );
			$relay->TeamTime[$team]['temp'] = $output;
			} else {
			$relay->TeamTime[$team]['temp'] = 0;
		}
		
	$relay->scorepanel_on();
}

function getChallengeList() {
global $aseco, $relay;
	if (count($relay->Cache['Challenges']) == 0 ) {
	
	$aseco->client->resetError();
	$newlist = array();
	$done = false;
	$size = 300;
	$i = 0;
	while (!$done) {
		$aseco->client->query('GetChallengeList', $size, $i);
		$tracks = $aseco->client->getResponse();
		if (!empty($tracks)) {
			if ($aseco->client->isError()) {
				// warning if no tracks found
				if (empty($newlist))
					trigger_error('[' . $this->aseco->client->getErrorCode() . '] ' . $this->aseco->client->getErrorMessage() . ' No tracks found!', E_USER_WARNING);
				$done = true;
				break;
			}
			
			foreach ($tracks as $trow) {
				$trow['Name'] = stripNewlines($trow['Name']);
				$trackinfo = getChallengeData($aseco->server->trackdir . $trow['FileName'], false);
					if ($trackinfo['name'] != 'file not found') {
						$trow['AuthorTime'] = $trackinfo['authortime'];
					}
				$newlist[$trow['UId']] = $trow;
			}
			if (count($tracks) < $size) {
				// got less than 300 tracks, might as well leave
				$done = true;
			} else {
				$i += $size;
			}
		} else {
			$done = true;
		}
	}

	$relay->Cache['Challenges'] = $newlist;
	return $newlist;
	}
	else {

	 return $relay->Cache['Challenges'];
	 }
}

function selectEnvironment($aseco, $login) {
global $aseco, $relay;
	$player = $aseco->server->players->getPlayer($login);
	
		$head = T_('Vote to select Environment');
		$msg = '';
		$tid = 1;
		$lines = 0;
		$player->msgs = array();
		$player->msgs[0] = 1;
		$msg = array();
		$msg[] = array(T_('Environment'), T_('Votes'));
		$extra = ($aseco->settings['lists_colortracks'] ? 0.2 : 0);
		
		$player->envlist = array();
		
		$player->msgs[0] = array(1, $head, array(1.0+$extra, 0.5, 0.2), array('Icons128x128_1', 'NewTrack', 0.02));
		$newlist = array("Alpine","Bay","Coast","Island","Rally","Speed","Stadium");
		foreach ($newlist as $data) {
		
				$trkarr = array();
				$trkarr['env'] = $data;
				$player->envlist[] = $trkarr;

				$vote = count($relay->Votes['Environment'][$data]);
		
				// add clickable buttons
				if ($aseco->settings['clickable_lists'] && $tid <= 111900) {
					$trackname = array($data, $tid+11200);  // action id
					}
			
				$msg[] = array($trackname, $vote);
				$tid++;
				$lines++;
				if ($lines > 14) {
					$player->msgs[] = $msg;
					$lines = 0;
					$msg = array();
					$msg[] = array(T_('Environment'), T_('Votes'));
				}
			  }
			
		// add if last batch exists
		if (count($msg) > 1) $player->msgs[] = $msg;
	

		display_manialink_multi($player);
}

function selectChallenge($aseco, $login) {
global $aseco, $relay;

	$player = $aseco->server->players->getPlayer($login);
	$params = explode(' ', $command['params']);
	$player->tracklist = array();
	$env = $relay->Votes['SelectedEnvironment'];
	
	// get cached list of players.
	$newlist = getChallengeList();
		$head = T_('Vote to select Track');
		$msg = '';
		$tid = 1;
		$lines = 0;
		$player->msgs = array();
		$player->msgs[0] = 1;
		$msg = array();
		$msg[] = array(T_('Name'),'Env', T_('Votes'));
		// reserve extra width for $w tags
		$extra = ($aseco->settings['lists_colortracks'] ? 0.2 : 0);
		
		$player->msgs[0] = array(1, $head, array(1.0+$extra, 0.5, 0.2, 0.2,0.2), array('Icons128x128_1', 'NewTrack', 0.02));
			
		foreach ($newlist as $data) {
		
			$row = $newlist[$data['UId']];  // indexed by uid
				
			if ($row['Environnement'] == $env) {
			
				$trkarr = array();
				$trkarr['name'] = $row['Name'];
				$trkarr['author'] = $row['Author'];
				$trkarr['environment'] = $row['Environnement'];
				$trkarr['filename'] = $row['FileName'];
				$trkarr['uid'] = $row['UId'];
				$player->tracklist[] = $trkarr;
				
				// format track name
				$trackname = $row['Name'];
				
				if (!$aseco->settings['lists_colortracks'])
					$trackname = stripColors($trackname);
				
				// format author name
				$trackauthor = $row['Author'];
				$authortime = $row['AuthorTime'];
				$vote = count($relay->Votes['Track'][$row['UId']]);
				// format env name
				$trackenv = $row['Environnement'];
				
				// add clickable button
				
				if ($aseco->settings['clickable_lists'])
					$trackenv = array($trackenv, $envids[$row['Environment']]);

				// add clickable buttons
				if ($aseco->settings['clickable_lists'] && $tid <= 111900) {
					$trackname = array($trackname, $tid+11100);  // action ids
					$trackauthor = array($trackauthor, $tid+11100);
					}
			
				$msg[] = array($trackname, $trackenv, $vote);
				$tid++;
				$lines++;
				if ($lines > 14) {
				$lines = 0;
				break;
					$player->msgs[] = $msg;
					$lines = 0;
					$msg = array();
					$msg[] = array(T_('Name'),'Env', T_('Votes'));
				}
			  }
			}
		// add if last batch exists
		if (count($msg) > 1) $player->msgs[] = $msg;

		display_manialink_multi($player);
}


function event_trackselect($aseco, $answer) {
global $relay, $aseco;

$login = $answer[1];

	if ($answer[2] >= 11101 && $answer[2] <= 11199) {
		$player = $aseco->server->players->getPlayer($answer[1]);
		
		$trackname = $player->tracklist[abs($answer[2])-11101]['filename'];
		$uid = $player->tracklist[abs($answer[2])-11101]['uid'];
	
		if ( !empty($relay->Votes['Track'])) {
			foreach ($relay->Votes['Track'] as $uuid => $track) {
				foreach ($track as $data) {
					if ($data == $login) unset($relay->Votes['Track'][$uuid][$login]);
				}
			}
		}
		
		$relay->Votes['Track'][$uid][$login] = $login;
		
	 // update votes for all
	foreach( $aseco->server->players->player_list as $pl) {

	selectChallenge($aseco, $pl->login);
	}
	
	}
	
	if ($answer[2] >= 11201 && $answer[2] <= 11900) {
		$player = $aseco->server->players->getPlayer($answer[1]);
		
		$env = $player->envlist[abs($answer[2])-11201]['env'];
		
		if ( !empty($relay->Votes['Environment'])) {
			foreach ($relay->Votes['Environment'] as $eenv => $track) {
				foreach ($track as $data) {
					if ($data == $login) unset($relay->Votes['Environment'][$eenv][$login]);
				}
			}
		}
		
		$relay->Votes['Environment'][$env][$login] = $login;

	foreach( $aseco->server->players->player_list as $pl) {
	selectEnvironment($aseco, $pl->login);
	}
	
	}
}

function relay_connect($aseco, $command) {
global $relay;
$login = $command->login;
$relay->preloadAudio($login);
$pl = $aseco->server->players->getPlayer($login);
$message = "Connection: \$n($login)\$z ".$pl->nickname;
//print "Connetion ".$relay->GameState;
if ( $relay->settings['SETTINGS']['GAME'][0]['SHOW_CONNECT_INFO'][0] == 'true') $aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));

if ($relay->GameState != "off") {
$relay->logo_on();
}

if ($relay->GameState == "selectTeams") {
	$relay->setSpectator($login, 0);
	$relay->teamSelect();
}

if ($relay->GameState == "raceReady") {
	$relay->setSpectator($login, 0);
	$relay->teamSelect();
}

if ($relay->GameState == "selectEnvironment") { 
	$relay->setSpectator($login, 1);
	selectEnvironment($aseco,$login);
}

if ($relay->GameState == "selectChallenge") { 
	$relay->setSpectator($login, 1);
	selectChallenge($aseco,$login);
}

if ($relay->GameState == "end") {
	$relay->setSpectator($login, 1);
	$relay->scoreScreen();
	}

if ($relay->GameState == "points") {
	$relay->setSpectator($login,1);
	$relay->pointScreen();
	}
	

if ($relay->GameState == "race") {
	$relay->setSpectator($login, 1);
	
	$slot = $relay->getPlayerAttrByLogin($login, "login");

		if ($slot !== false) {
		$relay->setPlayerAttrByLogin($login,"enabled",1);
		$nick = $relay->getPlayerAttrByLogin($login, "nickname");
		$message = "Welcome back ".$nick;
		$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
			
		$team = $relay->getPlayerAttrByLogin($login,"Team");
		$relay->showPlayers();
		}
		 else {
		 	$header = T_('Welcome to RelayRace!');
					$help = array();
					$help[] = array('{#server}'.T_('Welcome!'));
					$help[] = array('{#black}'.T_('This server is now configured in RelayRace-mode'));
					$help[] = array('{#black}'.T_('You can join to play after this races finishes.'));
					$help[] = array('{#black}');						
					$help[] = array('{#black}'.T_('Rules are simple:'));
					$help[] = array('{#black}'.T_('1) players select teams'));
					$help[] = array('{#black}'.T_('2) race is played in turns, aim for best time of team'));
					$help[] = array('{#black}');						
					$help[] = array('{#black}'.T_('Have fun!'));
					$help[] = array('{#black}');						
					// display ManiaLink message
					display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.0, 1.0), 'OK');
		}
		$relay->showPlayers();
		
	}
	
}

	function relay_disconnect($aseco, $command) {
		global $relay;
		$login = $command->login;

		$pl = $aseco->server->players->getPlayer($login);
		$message = "Disconnect: \$n($login)\$z ".$pl->nickname;
		if ( $relay->settings['SETTINGS']['GAME'][0]['SHOW_CONNECT_INFO'][0] == 'true') $aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
		//print "Disconnected on gamestate:".$relay->GameState;

		if ($relay->GameState == "selectTeams") {
			$relay->setPlayerAttrByLogin($login,"enabled",0);
			$relay->setPlayerAttrByLogin($login,"ready",0);
			$relay->setPlayerAttrByLogin($login,"Id",-1);
			$relay->setPlayerAttrByLogin($login,"Team",-1);
			$relay->teamSelect();
		} 
		
		if ($relay->GameState == "raceReady") {
			$relay->setPlayerAttrByLogin($login,"enabled",0);
			$relay->setPlayerAttrByLogin($login,"inRace",0);
		} 
		
		if ($relay->GameState == "race") {
			$slot = $relay->getPlayerAttrByLogin($login, "login");
			if ($slot !== false) {
			$team = $relay->getPlayerAttrByLogin($login,"Team"); //get team 
			$relay->setPlayerAttrByLogin($login,"enabled",0);
			$inrace = $relay->getPlayerAttrByLogin($login,"inRace"); // get inrace status
			$relay->setPlayerAttrByLogin($login,"inRace",0);  // set player inactive
			}
			
			if ($inrace == 1) {
				if ( count($relay->finishedPlayers[$team]) <= ($relay->Laps-1) ) {
					$nextLogin = $relay->GetNextPlayerInTeam($team,$login);
					if ($nextLogin) {
						$relay->setPlayerAttrByLogin($nextLogin,"inRace",1);
						$time = $relay->getTime();
						$relay->setPlayerAttrByLogin($nextLogin,"inStamp", $time);			
						$relay->setSpectator($nextLogin,2);
					} 
				}
			}
			
			if( $team != -1 && $slot !== false )  {
				
					$teams = $relay->playerSearch("Team",$team);
					$tcount = 0;
						foreach ($teams as $data) {
						if ($data['enabled']) $tcount++;
						}	
								
						if ($tcount == 0) {
							for ($x=count($relay->finishedPlayers[$team]); $x < $relay->Laps; $x++) {
							$relay->finishedPlayers[$team][]++; 
							}
						$relay->TeamTime[$team]['score'] = 999999999;
						$relay->TeamDisq[$team] = 1;
						}
					}
					
			$relay->showPlayers();	
			$relay->checkGameEnd();		
			}
	}

function relay_PlayerFinish($aseco,$command) 
	{
	global $relay;
	$relay->PlayerFinish($command);
	}
	

function event_relayrace($aseco, $answer) {
	/// $answer[0]=PlayerUid, $answer[1]=Login, $answer[2]=Answer
	global $relay;
	$login =  $answer[1];
	
	if ($relay->GameState == "race") {

	if ($answer[2] == 10003) { // set spectator
	$relay->showGiveUp($login);
	}

	if ($answer[2] == 10004) { // set spectator
	$relay->Giveup($login);
	}

	if ($answer[2] == 10005) { // set spectator
	$relay->hideGiveUp($login);
	}

	}
	
	if ($relay->GameState != "selectTeams") { 
	return;
	}

	$login = $answer[1];
	$player = $aseco->server->players->getPlayer($answer[1]);	
		$command = array();
		$command['author'] = $player;
		$command['params'] = "";
		
	if ($answer[2] >= 9001 && $answer[2] <= 9200) {
		
		// reset previous value
		$slot = ($answer[2]-9001);
		$relay->removePlayer($login);
		$relay->addPlayer($login,$slot);	
		$relay->teamSelect();
		$relay->sendAudioSelect($login);
		}
		
		if ($answer[2] == 10000) { // put ready flag
		$id = $relay->getPlayerAttrByLogin($login,"Id");
		if ($id !== false){
		$relay->setPlayerAttrByLogin($login,"ready",1);
		$relay->teamSelect();
		$relay->sendAudioDone($login);
		}
		}
		
		if ($answer[2] == 10001) { // set spectator
		$relay->removePlayer($login);
		$relay->addSpectator($login);
		$relay->setPlayerAttrByLogin($login,"ready",1);
		$relay->teamSelect();
		$relay->sendAudioDone($login);
		}
		

}  // event


// Class system
class RelayRace
	{
	public $Aseco;
	public $nextChallenge;
	public $Counters = array();
	public $Players = array();
	public $TeamTime = array();
	public $TeamNames = array();
	public $TeamDisq = array();
	public $TeamLock = array();
	public $spectators;
	public $GameState;
	public $finishedPlayers = array();
	public $Votes = array();
	public $Cache = array();
	public $TeamCount;
	public $TeamMaxPlayers;
	public $Laps;
	public $settings;
	public $manialinkID = 9000;
	

	function counters() {
		$select = $this->Counters['selectChallenge'];
		$env = $this->Counters['selectEnvironment'];
		$team = $this->Counters['selectTeams'];

		if ($this->Counters['selectTeams']['enabled'] == 1) {
			$this->GameState = "selectTeams";
			$this->Counters['selectChallenge']['enabled'] = 0;

    $this->Aseco->client->query('GetWarmUp');
    $wu=$this->Aseco->client->getResponse();
    if ( $wu <> 1 ) {	// warmup ended		
			//Check for that atleast one player has selected a team
				  $this->Counters['selectTeams']['enabled'] = 0;
				  $this->Counters['selectTeams']['count'] = 0;
				  $this->MLresetAll();
				  $this->GameState = "raceReady";
		
		} else {
			$this->Counters['selectTeams']['count']++;
			//$this->displayCounter($this->Counters['selectTeams']['count'],$team['Timeout']);
		}
	}

	if ($select['enabled']) {
	
		$this->GameState = "selectChallenge";

		if ($select['count'] == $select['Timeout']) {
			// If no votes, fallback to enviroment selection
			
			if (count($this->Votes['Track']) == 0) {
					
			$this->Counters['selectChallenge']['count'] = 0;
			$this->Counters['selectChallenge']['enabled'] = 0;
			$this->Counters['selectEnvironment']['enabled'] = 1;
			foreach( $this->Aseco->server->players->player_list as $pl) {
					selectEnvironment($this->Aseco, $pl->login);
				}
				
			} 
			else {
			
				$this->Counters['selectChallenge']['enabled'] = 0;   // reset counter
				$this->Counters['selectChallenge']['count'] = 0;	
			
				foreach ($this->Votes['Track'] as $uuid => $track) {
					$trackVote[count($track)][] = $uuid;
				}
		
				krsort($trackVote);
				foreach($trackVote as $data) {
					$vote[] = $data[0];				 //needs to add randomize function
				}		
				
				$challenges = getChallengeList();
				foreach ($challenges as $data) {
					if ( $data['UId'] == $vote[0] ) $track = $data['FileName'];
				}
		
				$this->nextChallenge = $track;	
				$this->Aseco->client->query('ChooseNextChallenge', $this->nextChallenge); 
				$this->Aseco->client->query('NextChallenge'); 
				$this->allSpecOff(); /// force specoff
				
				$this->GameState = "selectTeams";
				$this->Counters['selectTeams']['enabled'] = 2; 
//				$this->teamSelect();   // do team select
  		}
			
		} else {
			$this->Counters['selectChallenge']['count']++;
			$this->displayCounter($this->Counters['selectChallenge']['count'],$select['Timeout']);
		}

	}

	if ($env['enabled']) {
		$this->GameState = "selectEnvironment";
			if ( !empty($this->settings['SETTINGS']['GAME'][0]['DEFAULT_ENVIRONMENT'][0]) ) {
				$this->Counters['selectEnvironment']['count'] = 0;
				$this->Counters['selectEnvironment']['enabled'] = 0;
				$this->Votes['SelectedEnvironment'] = $this->settings['SETTINGS']['GAME'][0]['DEFAULT_ENVIRONMENT'][0];
				$this->Counters['selectChallenge']['enabled'] = 1; 
				$this->GameState = "selectChallenge";
				
				//display selectChallenge to players
				 shuffle_assoc($this->Cache['Challenges']);
				foreach( $this->Aseco->server->players->player_list as $pl) {
					selectChallenge($this->Aseco, $pl->login);
				}
				return;
				}
					
		if ($env['count'] == $env['Timeout']) {
	
			if (count($this->Votes['Environment']) == 0) {
				$this->Counters['selectEnvironment']['count'] = 0;
			
					foreach( $this->Aseco->server->players->player_list as $pl) {
					selectEnvironment($this->Aseco, $pl->login);
					}
				return;
				}
				
				$this->Counters['selectEnvironment']['enabled'] = 0;   // reset counter
				$this->Counters['selectEnvironment']['count'] = 0;	
			// Read votes, sort & select winner
				foreach($this->Votes['Environment'] as $env => $data) { 
					$enVote[count($data)][] = $env;
				}
				
				krsort($enVote);
				foreach($enVote as $data) {
					$vote[] = $data[0];					 //needs to add randomize function
				}

				$this->Votes['SelectedEnvironment'] = $vote[0];
				
				$this->Counters['selectChallenge']['enabled'] = 1; 
				$this->GameState = "selectChallenge";
				
				//display selectChallenge to players
				 shuffle_assoc($this->Cache['Challenges']);
				foreach( $this->Aseco->server->players->player_list as $pl) {
					selectChallenge($this->Aseco, $pl->login);
				}
				
			} 	
			else {
				$this->Counters['selectEnvironment']['count']++;
				$this->displayCounter($this->Counters['selectEnvironment']['count'],$env['Timeout']);
			}
		}
	
  	if ($this->Counters['showScoreboard']['enabled'] == 1) {
			$this->Counters['finishTeam']['enabled'] = 0;
			$this->GameState = "end";
			if ($this->Counters['showScoreboard']['count'] == $this->Counters['showScoreboard']['Timeout']) { 

			  $this->Counters['showScoreboard']['enabled'] = 0;
		    $this->Counters['showScoreboard']['count'] = 0;
//		    $this->Aseco->client->query('ChatSendServerMessage', 'New Relay Race !');	
        if ($this->compmax == 0) { 
		      $this->MLresetAll();
 		      $this->resetCounters();
		      $this->resetgame();
		      return;
		    } else {
		      $this->Counters['showPoints']['enabled'] = 1;
		      $this->comprnd = $this->comprnd+1;
		      $this->pointScreen();
        }
		  } else {
		  $this->Counters['showScoreboard']['count']++;
		  $this->displayCounter($this->Counters['showScoreboard']['count'],$this->Counters['showScoreboard']['Timeout']);
		  }
	  }

  	if ($this->Counters['showPoints']['enabled'] == 1) {
			$this->Counters['showScoreboard']['enabled'] = 0;
			$this->GameState = "points";
			if ($this->Counters['showPoints']['count'] == $this->Counters['showPoints']['Timeout']) { 

			  $this->Counters['showPoints']['enabled'] = 0;
		    $this->Counters['showPoints']['count'] = 0;
        $this->MLresetAll();
	      $this->resetCounters();
	      $this->resetgame();
	      return;

		  } else {
		  $this->Counters['showPoints']['count']++;
		  $this->displayCounter($this->Counters['showPoints']['count'],$this->Counters['showPoints']['Timeout']);
		  }
	  }
	
	if ($this->Counters['finishTeam']['enabled'] == 1) {
		if ($this->Counters['finishTeam']['count'] == $this->Counters['finishTeam']['Timeout']) { 
		$this->Counters['finishTeam']['enabled'] = 0;
			
		foreach ($this->finishedPlayers as $team => $data) {
			if (count($data) < $this->Laps) {
//				$this->TeamTime[$team]['score'] = 999999999;			
			}
		}	
		$this->ScoreScreen();
		$this->Counters['showScoreboard']['enabled'] = 1;
		
		return;
		 } 
		 else {
		 $this->Counters['finishTeam']['count']++;
		  $this->displayCounter($this->Counters['finishTeam']['count'],$this->Counters['finishTeam']['Timeout']);
		 }
  	
	}
}
	
	function resetgame() {
		$tempPlayers = $this->Players;
		unset($this->Players);
		$this->Players= array();		
		foreach( $this->Aseco->server->players->player_list as $data) {
			foreach ( $tempPlayers as $login => $player) {
				if ($data->login == $login) {
					if ($player['enabled'] != 0) { 
						$this->Players[$login] = $player;
						$this->setPlayerAttrByLogin($login, "ready", 0);
						$this->setPlayerAttrByLogin($login, "inRace", 0);
					}
				}
			}
		}
		unset($tempPlayers);
		unset($this->Votes);
		unset($this->TeamTime);
		unset($this->Cache);
		getChallengeList();
		$this->spectators = 0;
		$this->finishedPlayers = array();
		$this->TeamDisq = array();
		$this->TeamTime= array();
		$this->MLresetAll();
		$this->allSpec();
		$this->resetCounters();

    $this->startok=0;
		if ($this->skipenv == 1) {

		  $this->Aseco->client->query('NextChallenge'); 
		  $this->allSpecOff(); /// force specoff
		  $this->GameState = "selectTeams";
		  $this->Counters['selectTeams']['enabled'] = 2; 
		  return;
		}
	
			// Set counter + show selector to players;
			$this->GameState = "selectEnvironment";
			$this->Counters['selectEnvironment']['enabled'] = 1;
			
			foreach( $this->Aseco->server->players->player_list as $pl) {
				selectEnvironment($aseco, $pl->login);
			}
		
		
		
	}

function checkOnlinePlayers() {
		foreach ($this->Players as $pl) {
				$data = $this->Aseco->server->players->getPlayer($pl['login']);
				
				if ( empty($data) ) { 
				/*	$this->setPlayerAttrByLogin($pl['login'],"enabled",0);
					$this->setPlayerAttrByLogin($pl['login'],"inRace",0); */
					unset($this->Players[$pl['login']]);
					}
					
				}
}
/*
				START RACE
*/	

	function startRace() {
		$this->GameState = "race";
		$this->startok = 0;
		$this->resetCounters();
		$this->allSpec();  // force spectators;
		$this->TeamTime = array();
		$this->checkOnlinePlayers();
		

				
		// Release first players		
		for($x=0; $x < $this->TeamCount; $x++) {
			$login = $this->GetNextPlayerInTeam($x, '');
			if (!empty($login)) {
				$this->setPlayerAttrByLogin($login,"inRace",1);
				$time = $this->getTime();
				$team = $this->getPlayerAttrByLogin($login, "Team");
				$this->TeamTime[$team]['team'] = $team; 
				$this->setPlayerAttrByLogin($login,"inStamp", $time);
				$this->setSpectator($login,2);
			}
		}
		$this->showPlayers();
		if ($this->compmax>0) {
		  $rnd=$this->comprnd+1;
		  $message = sprintf(T_('$fffSTART $0f0Relay Race, $fff %d $0f0 stages, Round $fff%d $0f0!'), $this->Laps, $rnd) ;
    } else {
      $message = sprintf(T_('$fffSTART $0f0Relay Race, $fff%d$0f0 stages !'), $this->Laps);
    }
		$this->Aseco->client->query('ChatSendServerMessage', $message);
	}

	
	function setTeamTime($team,$login) {
		$starttime = $this->getPlayerAttrByLogin($login,"inStamp");
		$time = $this->getTime();
		
		$output = abs($starttime - $time);
		$this->TeamTime[$team]['team'] = $team;
		$this->TeamTime[$team]['score'] = $this->TeamTime[$team]['score'] + $output;
		$this->TeamTime[$team]['temp'] = 0;
	}

	
	function PlayerFinish($command) {
		$login = $command->player->login;
		$score = $command->score;
		$team = $this->getPlayerAttrByLogin($login,"Team");
		$inRace = $this->getPlayerAttrByLogin($login,"inRace");

		if ($this->GameState != "race") return;  // get back if game is not on
		if (!$inRace) return; // if player isnt inrace, return. Avoid null-teams to teamtime.
		
			if ($score == 0) {
  			$this->TeamTime[$team]['tempCP'] = 0;
			return;  // get back if player didnt get to finish and restarted 
			}
			
			$this->TeamTime[$team]['CPs'] = $this->TeamTime[$team]['CPs'] + $this->TeamTime[$team]['tempCP'];
			$this->setTeamTime($team,$login); // add time to counter
			$nextLogin = $this->GetNextPlayerInTeam($team,$login);
			$this->setPlayerAttrByLogin($login, "inStamp", 0);
							
			if ( count($this->finishedPlayers[$team]) >= $this->Laps-1 ) {
				$this->setPlayerAttrByLogin($login,"inRace",0);
				$this->setSpectator($login,1);
				$this->finishedPlayers[$team][]++; 
				$this->TeamTime[$team]['tempCP'] = 0;
				$message = '$fff'.$this->TeamNames[$team].' $z$f80'.T_('FINISHED! time').' $fff'.formatTime($this->TeamTime[$team]['score']);
				$this->Aseco->client->query('ChatSendServerMessage', $message);
				$this->hideGiveUp($login); 
				$this->Counters['finishTeam']['enabled'] = 1;   // starts the finishing counter for other teams to get finish, doesn't matter if it's initalized multiple times
			}
			else {
				$this->finishedPlayers[$team][]++; 
				
				if ($nextLogin != $login) {
					$this->setPlayerAttrByLogin($login,"inRace",0);
					$this->setSpectator($login,1);
					$this->hideGiveUp($login); 
					$this->setPlayerAttrByLogin($nextLogin,"inRace",1);		
					$time = $this->getTime();
					$this->setPlayerAttrByLogin($nextLogin,"inStamp", $time);
					$this->setSpectator($nextLogin,2);
					// $this->Aseco->client->query('ForceSpectatorTarget', $login, $nextLogin, 1);
					$this->TeamTime[$team]['tempCP'] = 0;
					} 
				else {
					$this->TeamTime[$team]['tempCP'] = 0;
					$this->setSpectator($login,1); //put player to spectator 
					$time = $this->getTime();
					$this->setPlayerAttrByLogin($login,"inStamp", $time);
					$this->setSpectator($login,2); //and bring him back to game, to prevent key pressing when finish
				}
			}
			$this->showPlayers();
			$this->checkGameEnd();		
	}


	function checkGameEnd() {

		foreach ($this->Players as $data) {
			if ($data['Team'] != -1) {
			$tcount[$data['Team']] = 1;
			}
		}
		
		$teamcount = count($tcount);
		$counter = 0;
		foreach ($this->finishedPlayers as $team => $data) {
			if (count($data) >= $this->Laps) {
				$counter++;
			} 
		}
		relay_debug("endgame counter:".$counter." teamcount: ".$teamcount);
		if ( $counter == $teamcount || count($this->Players) == 0 ) {
			$this->ScoreScreen();
			$this->Counters['showScoreboard']['enabled'] = 1;
    }
  }
  	
/* 				SCORE SCREEN							*/
	function scoreScreen_new() {
	$this->GameState = "";
	$this->MLresetAll();
	$this->allSpec();
	$manialinkID = $this->manialinkID;

			$hsize = 0.07;
			$bsize = 0.04;
			$csize = 0.05;
			$lines = 20;
			$widths = array("1.4");
			$header = T_("RelayRace Results");
			$style['WINDOW']['STYLE'] = "Bgs1";
			$style['WINDOW']['SUBSTYLE'] = "BgWindow3";
			$style['HEADER']['STYLE'] = "BgsPlayerCard";
			$style['HEADER']['SUBSTYLE'] = "BgRacePlayerName";
			$style['HEADER']['TEXTSTYLE'] = "TextTitle2";
			$style['BODY']['STYLE'] = "BgsPlayerCard";
			$style['BODY']['SUBSTYLE'] = "BgActivePlayerName";
			$style['BODY']['TEXTSTYLE'] = "TextTitle3";
			
			$style['ENTRY']['STYLE'] =  "BgsPlayerCard";
			$style['ENTRY']['SUBSTYLE'] =  "BgPlayerName";
			$style['ENTRY']['TEXTSTYLE'] = "TextTitle2";
			
			$style['BUTTON']['STYLE'] = "Bgs1InRace";
			$style['BUTTON']['SUBSTYLE'] = "NavButton";	
			
			// manialink header & window
			$xml  = '<manialink id="14000"><frame pos="' . ($widths[0]/2) . ' 0.5 0">' .
			'<quad size="' . $widths[0] . ' ' . (0.11+$hsize+$lines*$bsize) .
			'" style="' . $style['WINDOW']['STYLE'] .
			'" substyle="' . $style['WINDOW']['SUBSTYLE'] . '"/>' . LF;
			
			// header and icon
			$xml .= '<quad pos="-' . ($widths[0]/2) . ' -0.01 -0.1" size="' . ($widths[0]-0.02) . ' ' . $hsize .
			'" halign="center" style="' . $style['HEADER']['STYLE'] .
			'" substyle="' . $style['HEADER']['SUBSTYLE'] . '"/>' . LF;
			
			$xml .= '<label pos="-'.($widths[0]/2).' -0.025 -0.2" size="' . ($widths[0]-0.05) . ' ' . $hsize .
			'" halign="center" style="' . $style['HEADER']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars($header) . '"/>' . LF;
			
			//body
			/*$xml .= '<quad pos="-' . ($widths[0]/2) . ' -' . (0.02+$hsize) .
			' -0.1" size="' . ($widths[0]-0.02) . ' ' . (0.02+$lines*$bsize) .
			'" halign="center" style="' . $style['BODY']['STYLE'] .
			'" substyle="' . $style['BODY']['SUBSTYLE']. '"/>' . LF;*/
			
			$cnt = 0;
			$bnt = 0;
			$ord = 0;
			 foreach($this->TeamTime as $team => $score) { 
		    $sscore = $score['score'];
		    $ccp = $score['CPs'] + $score['tempCP'];
			$times[$team] = array("team" => $score['team'], "score" => $sscore, "CPs" => $ccp);
			}
		
			uasort($times,"relay_sort_pos");	
			foreach ($times as $data) {
			$cps = $data['CPs'];
			
			if ( empty($data['score']) ) $data['score'] = 999999999;
			//draw background
			$xml .= '<quad pos="-0.025 -' . ($hsize+($cnt*$csize)).
			' -0.2" size="' . ($widths[0]-0.04) . ' ' . (0.02+(2*$bsize)) .
			'" halign="left" style="' . $style['ENTRY']['STYLE'] .
			'" substyle="' . $style['ENTRY']['SUBSTYLE']. '"/>';
			
			//draw winner name
			$xml .= '<label pos="-0.13 -' . ($hsize+($cnt*$csize)+0.008) .
			' -0.2" size="0.6' . (0.02+$bsize) .
			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' . $this->TeamNames[$data['team']] . '"/>' . LF;
			
			//draw time
			$xml .='<quad style="Icons128x32_1" substyle="RT_TimeAttack" pos="-0.60 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.05 0.05"/>';
			
			if ($data['score'] == 999999999 ) { // jos tiimi on diskattu
				$xml .= '<label pos="-0.66 -' . ($hsize+($cnt*$csize)+0.008) .
				' -0.2" size="0.2 0.04" scale="0.6 0.6" halign="left" style="TextRaceChrono" 
				text="disqualified"/>' . LF;						
			} else {
			
				$xml .= '<label pos="-0.66 -' . ($hsize+($cnt*$csize)+0.008) .
				' -0.2" size="0.2 0.04" scale="0.6 0.6" halign="left" style="TextRaceChrono" 
				text="' . formatTime($data['score']) . '"/>' . LF;					
			}

  			$xml .='<quad style="Icons128x128_1" substyle="Race" pos="-0.92 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.05 0.05"/>';
				$xml .= '<label pos="-0.98 -' . ($hsize+($cnt*$csize)+0.008) .
				' -0.2" size="0.2 0.04" scale="0.6 0.6" halign="left" style="TextRaceChrono" 
				text="$FF8' . $cps . '"/>' . LF;				

// Team Points if comp enabled
      if ($this->compmax >= 1) {
        $xml .='<quad style="Icons128x128_1" substyle="Rankings" pos="-1.20 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.05 0.05"/>';
				$xml .= '<label pos="-1.26 -' . ($hsize+($cnt*$csize)+0.008) .
				' -0.2" size="0.2 0.04" scale="0.6 0.6" halign="left" style="TextRaceChrono" 
				text="$8FF' . $this->Points[$ord] . '"/>' . LF;				

        $this->teamPoints[$data['team']] = $this->teamPoints[$data['team']]+$this->Points[$ord]; 
      }
			
			/* //draw ladderpoints 
			$xml .='<quad style="Icons128x128_1" substyle="LadderPoints" pos="-0.83 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.05 0.05"/>';
			$xml .= '<label pos="-0.9 -' . ($hsize+($cnt*$csize)+0.008) .
			' -0.2" size="0.4 ' . (0.02+$bsize) .
			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars('$666'.$line['LP']) . '"/>' . LF;	
			//draw server rank 
			/*$xml .='<quad style="Icons64x64_1" substyle="TrackInfo" pos="-1.1 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.05 0.05"/>';
			$xml .= '<label pos="-1.15 -' . ($hsize+($cnt*$csize)+0.008) .
			' -0.2" size="0.4 ' . (0.02+$bsize) .
			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars('$666'.$line['srank']) . '"/>' . LF;	*/				
			
			//second line		
			$pl = $this->playerSearch("Team",$data['team']);
			$nicknames = "";
			foreach ($pl as $data2) {
			$nick = $this->getPlayerAttrByLogin($data2['login'],"nickname");
			$nicknames .='$z$s'.$nick.'   ';
			}
			
			$xml .= '<label pos="-0.13 -' . ($hsize+($cnt*$csize)+0.008+$bsize) .
			' -0.2" size="0.6' . (0.02+$bsize) .
			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' .$nicknames . '"/>' . LF;
			
			/*//draw ladderpoints 
			$xml .='<quad style="Icons64x64_1" substyle="ToolLeague1" pos="-0.83 -'.($hsize+($cnt*$csize)+$bsize).' -0.3" size="0.05 0.05"/>';
			$xml .= '<label pos="-0.9 -' . ($hsize+($cnt*$csize)+0.008+$bsize) .
			' -0.2" size="0.4 ' . (0.02+$bsize) .
			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars('$666'.$line['rank']) . '"/>' . LF;	
			
			//draw server rank 
			$xml .='<quad style="BgRaceScore2" substyle="Fame" pos="-1.1 -'.($hsize+($cnt*$csize)+$bsize).' -0.3" size="0.05 0.05"/>';
			$xml .= '<label pos="-1.15 -' . ($hsize+($cnt*$csize)+0.008+$bsize) .
			' -0.2" size="0.4 ' . (0.02+$bsize) .
			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars('$666'.$line['srank']) . '"/>' . LF;			
			*/
			
			//draw place numbers
			switch ($bnt) {
			
			case "0":
			$xml .='<quad style="Icons64x64_1" substyle="First"  pos="-0.06 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.07 0.07"/>';
			break;
			
			case "1":
			$xml .='<quad style="Icons64x64_1" substyle="Second"  pos="-0.06 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.07 0.07"/>';
			break;
			
			case "2":
			$xml .='<quad style="Icons64x64_1" substyle="Third"  pos="-0.06 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.07 0.07"/>';
			break;
			
			default :
			$xml .= '<label pos="-0.09 -' . ($hsize+($cnt*$csize)+0.02) .
			' -0.2" size="0.07 0.07" scale="1.4 1.4" 
			halign="center" style="' . $style['ENTRY']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars('$000'.($bnt+1)) . '"/>' . LF; 
			
			break;
			
			}
			
			$cnt=$cnt+2;
			$bnt++;
			$ord=$ord+1;
			}
			$xml .="</frame></manialink>";
			$this->Aseco->addCall('SendDisplayManialinkPage', array( $xml, 0, false));	
	
	}		

/* 				POINT SCREEN							*/
	function pointScreen() {
	$this->GameState = "";
	$this->MLresetAll();
	$this->allSpec();
	$manialinkID = $this->manialinkID;

			$hsize = 0.07;
			$bsize = 0.04;
			$csize = 0.05;
			$lines = 20;
			$widths = array("1.4");
			$header = T_("Points Standings - Round ").$this->comprnd ;
			if ($this->comprnd >= $this->compmax) {
			  $header = '$f00Final Points Standings';
			  $this->compmax=0;
      }
			$style['WINDOW']['STYLE'] = "Bgs1";
			$style['WINDOW']['SUBSTYLE'] = "BgWindow3";
			$style['HEADER']['STYLE'] = "BgsPlayerCard";
			$style['HEADER']['SUBSTYLE'] = "BgRacePlayerName";
			$style['HEADER']['TEXTSTYLE'] = "TextTitle2";
			$style['BODY']['STYLE'] = "BgsPlayerCard";
			$style['BODY']['SUBSTYLE'] = "BgActivePlayerName";
			$style['BODY']['TEXTSTYLE'] = "TextTitle3";
			
			$style['ENTRY']['STYLE'] =  "BgsPlayerCard";
			$style['ENTRY']['SUBSTYLE'] =  "BgPlayerName";
			$style['ENTRY']['TEXTSTYLE'] = "TextTitle2";
			
			$style['BUTTON']['STYLE'] = "Bgs1InRace";
			$style['BUTTON']['SUBSTYLE'] = "NavButton";	
			
			// manialink header & window
			$xml  = '<manialink id="14000"><frame pos="' . ($widths[0]/2) . ' 0.5 0">' .
			'<quad size="' . $widths[0] . ' ' . (0.11+$hsize+$lines*$bsize) .
			'" style="' . $style['WINDOW']['STYLE'] .
			'" substyle="' . $style['WINDOW']['SUBSTYLE'] . '"/>' . LF;
			
			// header and icon
			$xml .= '<quad pos="-' . ($widths[0]/2) . ' -0.01 -0.1" size="' . ($widths[0]-0.02) . ' ' . $hsize .
			'" halign="center" style="' . $style['HEADER']['STYLE'] .
			'" substyle="' . $style['HEADER']['SUBSTYLE'] . '"/>' . LF;
			
			$xml .= '<label pos="-'.($widths[0]/2).' -0.025 -0.2" size="' . ($widths[0]-0.05) . ' ' . $hsize .
			'" halign="center" style="' . $style['HEADER']['TEXTSTYLE'] .
			'" text="' . htmlspecialchars($header) . '"/>' . LF;
			
			$cnt = 0;
			$bnt = 0;
//			$ord = 1;
			//print "Sort Points and Rankings:\n";
			$numb=0;  // sort overall rank
			while ($numb < 8) {
				$i=0;
		    $this->teamRank[$numb]=0;
		    while ($i < 8) {
//		      if ($numb <> $i) {  // dont check self
		        if ($this->teamPoints[$numb] < $this->teamPoints[$i]) $this->teamRank[$numb]=$this->teamRank[$numb]+1;
		        if ($this->teamPoints[$numb] == $this->teamPoints[$i] && $numb > $i) $this->teamRank[$numb]=$this->teamRank[$numb]+1; // sort on equal by team num order
//            }
          $i=$i+1;
          }
        $this->sortRank[$this->teamRank[$numb]]=$numb; 
        //print "Loop:".$numb." teamPoints:".$this->teamPoints[$numb]." teamRank:".$this->teamRank[$numb]." sortRank:".$this->sortRank[$numb]." \n";
        $numb=$numb+1;  
        }
			
//			uasort($this->TeamTime,"relay_sort_pos");	
//			foreach ($this->TeamTime as $data) {
			$loop=0;
			while ($loop<8){
			  if ($this->teamPoints[$this->sortRank[$loop]] > 0){
			//draw background
  			$xml .= '<quad pos="-0.025 -' . ($hsize+($cnt*$csize)).
  			' -0.2" size="' . ($widths[0]-0.04) . ' ' . (0.02+(2*$bsize)) .
  			'" halign="left" style="' . $style['ENTRY']['STYLE'] .
  			'" substyle="' . $style['ENTRY']['SUBSTYLE']. '"/>';
			
  			//draw winner name
  			$xml .= '<label pos="-0.13 -' . ($hsize+($cnt*$csize)+0.008) .
  			' -0.2" size="0.6' . (0.02+$bsize) .
  			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
  			'" text="' . $this->TeamNames[$this->sortRank[$loop]] . '"/>' . LF;
			
  			//draw points
  			$xml .='<quad style="Icons128x128_1" substyle="Rankings" pos="-0.60 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.05 0.05"/>';

				$xml .= '<label pos="-0.68 -' . ($hsize+($cnt*$csize)+0.008) .
				' -0.2" size="0.2 0.04" scale="0.6 0.6" halign="left" style="TextRaceChrono" 
				text="$FFF' . $this->teamPoints[$this->sortRank[$loop]] . '"/>' . LF;		

  			//second line		
  			$pl = $this->playerSearch("Team",($this->sortRank[$loop]));
  			$nicknames = "";
  			foreach ($pl as $data2) {
  			$nick = $this->getPlayerAttrByLogin($data2['login'],"nickname");
  			$nicknames .='$z$s'.$nick.'   ';
  			}
			
  			$xml .= '<label pos="-0.13 -' . ($hsize+($cnt*$csize)+0.008+$bsize) .
  			' -0.2" size="0.6' . (0.02+$bsize) .
  			'" halign="left" style="' . $style['ENTRY']['TEXTSTYLE'] .
  			'" text="' .$nicknames . '"/>' . LF;
			
			   //draw place numbers
			   switch ($bnt) {
			
			  case "0":
		   	$xml .='<quad style="Icons64x64_1" substyle="First"  pos="-0.06 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.07 0.07"/>';
		   	break;
			
		   	case "1":
		   	$xml .='<quad style="Icons64x64_1" substyle="Second"  pos="-0.06 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.07 0.07"/>';
		   	break;
			
		   	case "2":
		   	$xml .='<quad style="Icons64x64_1" substyle="Third"  pos="-0.06 -'.($hsize+($cnt*$csize)+0.01).' -0.3" size="0.07 0.07"/>';
		   	break;
			
       	default :
		  	$xml .= '<label pos="-0.09 -' . ($hsize+($cnt*$csize)+0.02) .
		  	' -0.2" size="0.07 0.07" scale="1.4 1.4" 
		  	halign="center" style="' . $style['ENTRY']['TEXTSTYLE'] .
		  	'" text="' . htmlspecialchars('$000'.($bnt+1)) . '"/>' . LF; 
			
		  	break;
			
			  }
			}
			$cnt=$cnt+2;
			$bnt++;
			$loop=$loop+1;
			}
			$xml .="</frame></manialink>";
			$this->Aseco->addCall('SendDisplayManialinkPage', array( $xml, 0, false));	
	
	}		
	
	
function ScoreScreen() {
$this->scoreScreen_new();
return;
}


function checkTeamLock() {
	for ($i = 0; $i < $this->TeamCount; $i++) { 
		if ( count($this->playerSearch("Team",$i)) == 0) $this->TeamLock[$i] = 0;
	}
}

function teamSelect() {
		$this->checkOnlinePlayers();
		$this->checkTeamLock();
		$manialinkID= $this->manialinkID;
		$widths[0] = 1.5;		
		$header = "Relay Race - Select team";
		$online = count($this->Aseco->server->players->player_list);
		$selected = count($this->playerSearch('ready','1'));
		$specs = count($this->playerSearch('isSpec','1'));
		
		if ( $online == $selected && $selected > 0 && $this->GameState != "race" && $this->startok == 1 ) {      // Start race if conditions are set.
		$this->Counters['selectTeams']['enabled'] = 0;
		$this->Counters['selectTeams']['count'] = 0;
		$this->MLresetAll();
		
		$this->Aseco->client->query('GetWarmUp');
    $wu=$this->Aseco->client->getResponse();
    if ( $wu == 1 ) {
      $this->Aseco->client->query('ChallengeRestart');
      }
    $this->GameState = "raceReady";  
//		$this->startRace();
		return;
		} 

// build manialink header & window
// <quad halign="top" valign="left" image="http://koti.mbnet.fi/reaby/tmn/relay/black.jpg" posn="0 0 -1" sizen="128 90" />
		$readytext = T_("I'm Ready");
		$xml = '<manialinks>
			<manialink id="9000">
			<update>0</update>
			<frame pos="1 1 0">
			
			</frame>
			<frame pos="-0.75 0 0">
			<label halign="center" valign="center" pos="-0.125 0 -0.2" scale="0.9 0.9" text = "$000'.$readytext.'" />
		 	<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgCardChallenge" pos="-0.125 0 -0.2" size="0.26 0.06" action="'.(10000).'" />			
			</frame>
			
			<frame pos="-0.75 -0.07 0">
			<label halign="center" valign="center" pos="-0.125 0 -0.2" scale="0.7 0.7" text = "$000'.T_("Join as spectator").'" />
		 	<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgCardSystem" pos="-0.125 0 -0.2" size="0.26 0.06" action="'.(10001).'" />
			</frame>
			
			<frame pos="1 -0.45 0">' .
			
			'
			<format textsize="3" />
			<label halign="left" valign="center" posn="0 8 0" text="$ff8'.T_("RelayRace - Assign Teams").'" />
			<format textsize="1.5" />
			';
			$posx = 0.125;
			$playerSlot = 0;
	
			for ($i = 0; $i < $this->TeamCount; $i++) {
				$xml .='<label halign="center" valign="center" pos="-'.$posx.' 0.03 0" text="'.$this->TeamNames[$i].'" />';
				for ($o = 0; $o < $this->TeamMaxPlayers; $o++) {
				$posy = -$o*0.03;
				$player = $this->getPlayerById($playerSlot);
				
				if (empty($player) || $player['enabled'] == 0) {
						if ($this->TeamLock[$i] == 1 ){
						$xml .='<quad halign="center" valign="center" style="BgRaceScore2" substyle="HandleRed" pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03"/>';
						} 
						else {
						$xml .='<label  halign="center" size="0.24 0.03" valign="center" pos="-'.$posx.' '.$posy.' -0.2" text="'.T_('Click Here to Join').'" />';
						$xml .='<quad halign="center" valign="center" style="BgsPlayerCard" substyle="BgCard" pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" action="'.($manialinkID+$playerSlot+1).'" />';
						}
					}
						
				else {
					if ( $player['isSpec'] == 1 ) {
 						if ($this->TeamLock[$i] == 1 ){
						$xml .='<quad halign="center" valign="center" style="BgRaceScore2" substyle="HandleRed" pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03"/>';
						} 
						else {
							$xml .='<label  halign="center" size="0.24 0.03" valign="center" pos="-'.$posx.' '.$posy.' -0.2" text="'.T_('Click Here to Join').'" />';
							$xml .='<quad halign="center" valign="center"  style="BgsPlayerCard" substyle="BgCard"  pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" action="'.($manialinkID+$playerSlot+1).'" />';	
						}
					}
					else {		
						if ($player['ready'] == 1 ) {
						$xml .='<label  halign="center" size="0.24 0.03" valign="center" pos="-'.$posx.' '.$posy.' -0.2" text="'.$player['nickname'].'" />';		
						$xml .='<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgTitle3_4" pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" />';
						}
						else {
						$xml .='<label  halign="center" size="0.24 0.03" valign="center" pos="-'.$posx.' '.$posy.' -0.2" text="'.$player['nickname'].'" />';		
						$xml .='<quad halign="center" valign="center" style="BgsPlayerCard" substyle="BgRacePlayerName"  pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" />';
						}
						
					}
				
				}
				
				
				 
				$playerSlot++;							
				}
				$posx = $posx + 0.25;	
			}
			
			
			$xml .='</frame>';
			#ready counter 
			/*$xml .='<frame pos="0 0 0"><format textsize="1.5" />';
			$xml .= '<label halign="top" valign="left" pos="0 0 -0.2" text="$sReady count: '.$selected."/".$online.'" />';
			$xml .='</frame>'; */

		
			#spectators		
			$xml .='<frame pos="-0.6 0.3 0"><format textsize="1.5" />';
			$xml .= '<label halign="top" valign="left" pos="0 0 -0.2" text="$sSpectators:" />';
			$y = 1;
			if ($specs = $this->playerSearch("isSpec",1)  ) {
				foreach ($specs as $data ){
				$posy = -$y*0.04;
				$nick = $this->Players[$data['login']]['nickname'];
				$xml .= '<label halign="top" valign="left" pos="0 '.$posy.' -0.2" text="'.$nick.'" />';
				$y++;				
				}
			
			
			}
			$xml .='</frame>';
			
			
			
			
			$xml .='
			</manialink>
			</manialinks>';
			$this->Aseco->addCall('SendDisplayManialinkPage', array( $xml, 0, false));	
				}
		
	function logo_on() {
	$xml = '<manialinks>
		<manialink id="9999">
		<frame pos="0 0.80 0">
		<quad halign="center" valign="top" image="http://koti.mbnet.fi/reaby/tmn/relay/relayrace.png"  pos="0 0 0" scale="0.8 0.8" size="0.50 0.25" />
		</frame>
		</manialink>
		</manialinks>';
	if ($this->hideLogo == 0) $this->Aseco->addCall('SendDisplayManialinkPage', array($xml, 0, false));	
	}
	
	function logo_off() {
	$xml = '<manialinks>
		<manialink id="9999">
		</manialink>
		</manialinks>';
	$this->Aseco->addCall('SendDisplayManialinkPage', array($xml, 0, false));	
	}
	
	function showJoinTeam($login) {
					$header = T_('Remember to join a team!');
					$help = array();
					$help[] = array('');
					$help[] = array('$f00'.T_('Remember to join a team!'));
					$help[] = array('');
					// display ManiaLink message
					display_manialink($login, $header, array('Icons64x64_1', 'TrackInfo', -0.01), $help, array(1.0, 1.0), 'OK');			
	}
	
	function showPlayers() {
		$xml = '<manialinks>
		<manialink id="9000">
		<frame pos="1 -0.45 0">' .
		
		'
		<format textsize="1.5" />
		';
		$posx = 0.125;
		$playerSlot = 0;
		
		for ($i = 0; $i < $this->TeamCount; $i++) {
		if ( (count($this->finishedPlayers[$i])) >= $this->Laps) {   //stageCounter
			$stageCounter = "Done";
			} else {
			$stageCounter = (count($this->finishedPlayers[$i])+1).'/'.$this->Laps;
			}
			$xml .='<label halign="center" valign="center" pos="-'.$posx.' 0.03 0" text="$s'.$this->TeamNames[$i].' $z$s$ff0'.$stageCounter.'" />';
			for ($o = 0; $o < $this->TeamMaxPlayers; $o++) {
			$posy = -$o*0.03;
			$player = $this->getPlayerById($playerSlot);
			if (empty($player) || $player['enabled'] == 0) {
				$xml .='<quad halign="center" valign="center" style="BgsPlayerCard" substyle="BgCard"  pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" />';
				}
			else {
					 
					if ($player['enabled']  == 1 && $player['inRace'] == 1) {
					$xml .='<label size="0.24 0.03" halign="center" valign="center" pos="-'.$posx.' '.$posy.' -0.2" text="'.$player['nickname'].'" />';		
					$xml .='<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgTitle3_4" pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" />'; 
					} 
					elseif ($player['enabled']) {
					$xml .='<label size="0.24 0.03" halign="center" valign="center" pos="-'.$posx.' '.$posy.' -0.2" text="'.$player['nickname'].'" />';		
					$xml .='<quad halign="center" valign="center" style="BgsPlayerCard" substyle="BgCard" pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" />';
					}
					else {
					$xml .='<quad halign="center" valign="center" style="BgsPlayerCard" substyle="BgCard"  pos="-'.$posx.' '.$posy.' -0.1" size="0.24 0.03" />';
					}		
				}
			 
			$playerSlot++;							
			}
			$posx = $posx + 0.25;	
		}
		
		
		$xml .='</frame>';
		$xml .='
		</manialink></manialinks>
		';
		$xml2 = '<manialinks><manialink id="9000"> </manialink>
		<manialink id="17000"> 
			<frame pos="-0.85 0.2 0" scale="0.8 0.8">
			<label halign="center" valign="center" pos="-0.125 0 -0.2" text = "$000'.T_("Give up").'" />
		 	<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgCardSystem" pos="-0.125 0 -0.2" size="0.26 0.06" action="'.(10003).'" />			
			</frame>
		</manialink> 
		</manialinks>';
		
		$racers = $this->playerSearch('inRace','1');
		
		foreach ($racers as $data) {
		$inrace[$data['login']] = $data['login'];
		}
		foreach($this->Aseco->server->players->player_list as $pl) {
		
			if ($pl->login != $inrace[$pl->login]) {
			$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($pl->login, $xml, 0, false));	}
			else {
			$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($pl->login, $xml2, 0, false));
			}
		}
			
	}
	
	function scorepanel_on() {

	   global $aseco, $relay;
		if ($this->GameState != "race") return;

	   $maniapos = -1;   
	   $linkmaniapos = -0.2;
	   $linkmaniapos2 = -0;
	   $xml = '<manialink id="15000">';
	   $xml .= '<frame posn="68 0 0">';
	   if (empty($this->TeamTime)) return true;
	   
	   $times = array();
	   foreach($this->TeamTime as $score){ 
	   $sscore = $score['score']+$score['temp'];
	   $ccp = $score['CPs'] + $score['tempCP'];
		$times[] = array("team" => $score['team'], "score" => $sscore, "CPs" => $ccp);
	//	print "team:".$score['team']."  cp: $ccp\n";
		}
		
	   uasort($times,"relay_sort_pos");
	   
	   $diff = 0;
	   foreach($times as $data){
	   
			if ($this->TeamDisq[$data['team']] == 1) {
				$fteam = "\$f00X";
			} else {
			
			if ( (count($this->finishedPlayers[$data['team']])) >= $this->Laps) {   //stageCounter
				$fteam = "\$0f0X";
			} else {
				$fteam = (count($this->finishedPlayers[$data['team']])+1);	
			}
			}
			
		   $rpointinc++;
		   $linkmaniapos =  ($linkmaniapos - 3) ;
		   $linkmaniapos2 =  ($linkmaniapos2 - 3) ;
		   $maniapos =  ($maniapos - 3) ;
			$time = 0;
			
			if ($rpointinc == 1) { 
			 $diff = $data['score'];
	  			if ($this->TeamDisq[$data['team']] == 1) {
//				$xml .= '<format textsize="1"/><label posn="-22.1 ' . $linkmaniapos . ' 1.5" sizen="30 3 2" halign="right" scale="0.3" style="TextRaceChrono" text="$s$ff0--:--.--"/>'; 
				$xml .= '<format textsize="1"/><label posn="-24.7 ' . $linkmaniapos . ' 1.5" sizen="30 3 2" halign="right" scale="0.3" style="TextRaceChrono" text="$s$ff0--:--.--"/>'; 

				 }
				 else {
//				$xml .= '<format textsize="1"/><label posn="-22.1 ' . $linkmaniapos . ' 1.5" sizen="30 3 2" halign="right" scale="0.3" style="TextRaceChrono" text="$s$ff0'.formatTime($data['score']).'"/>'; 
				$xml .= '<format textsize="1"/><label posn="-24.7 ' . $linkmaniapos . ' 1.5" sizen="30 3 2" halign="right" scale="0.3" style="TextRaceChrono" text="$s$ff0'.formatTime($data['score']).'"/>'; 

				 }
//				$xml .= '<format textsize="1"/><label posn="-19.3 ' . $linkmaniapos. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0'.$fteam.' "/>';
//				$xml .= '<format textsize="1"/><label posn="-30' . $linkmaniapos. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0f0'.$data['CPs'].' "/>';		
//				$xml .= '<format textsize="1.7"/><label posn="-16.5 ' . $linkmaniapos . ' 1.6" sizen="12 3 2" halign="left" text="$s$fff' .$this->TeamNames[$data['team']]. ' "/>';

//			  $xml .= '<quad sizen="4 3" posn="-19.6 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
//			  $xml .= '<quad sizen="6.8 3" posn="-24.9 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
//			  $xml .= '<quad sizen="17 3" posn="-17.4 ' . $maniapos . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';

				$xml .= '<format textsize="1"/><label posn="-21.5 ' . $linkmaniapos. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0b0'.$fteam.' "/>';
				$xml .= '<format textsize="1"/><label posn="-17.3' . $linkmaniapos. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$2f0'.$data['CPs'].' "/>';		
				$xml .= '<format textsize="1.7"/><label posn="-14.5 ' . $linkmaniapos . ' 1.6" sizen="12 3 2" halign="left" text="$s$fff' .$this->TeamNames[$data['team']]. ' "/>';

			  $xml .= '<quad sizen="6.8 3" posn="-27.4 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
			  $xml .= '<quad sizen="4 3" posn="-21.8 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
			  $xml .= '<quad sizen="4 3" posn="-17.6 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
			  $xml .= '<quad sizen="17 3" posn="-15.4 ' . $maniapos . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';

// header
//  			$xml .= '<quad sizen="2.0 2.0" posn="-25 -1 1"  valign="center" halign="center" style="BgRaceScore2" substyle="ScoreLink" />';
				$xml .= '<format textsize="1"/><label posn="-27.4 -0.2 1.5" sizen="30 3 2" halign="center" text="$s$bbbTime "/>'; 
				$xml .= '<format textsize="1"/><label posn="-21.5 -0.2 1.5" sizen="30 3 2" halign="center" text="$s$bbbLeg "/>';
				$xml .= '<format textsize="1"/><label posn="-17.3 -0.2 1.5" sizen="30 3 2" halign="center" text="$s$bbbCP "/>';		
				$xml .= '<format textsize="1.7"/><label posn="-14.5 -0.2 1.6" sizen="12 3 2" halign="left" text="$s$bbbTeam "/>';

			  $xml .= '<quad sizen="6.8 3" posn="-27.4 -1 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
			  $xml .= '<quad sizen="4 3" posn="-21.8  -1 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
			  $xml .= '<quad sizen="4 3" posn="-17.6  -1 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
			  $xml .= '<quad sizen="17 3" posn="-15.4  -1 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';

			}
			
		   if ($rpointinc != 1) { 
		   $time = abs($diff - $data['score']);
		   			if ($this->TeamDisq[$data['team']] == 1) {
				$xml .= '<format textsize="1"/><label posn="-24.7 ' . $linkmaniapos . ' 1.5" sizen="30 3 2" halign="right" scale="0.3" style="TextRaceChrono" text="$s$ff0--:--.--"/>'; 
				 }
				 else {
				$xml .= '<format textsize="1"/><label posn="-24.7 ' . $linkmaniapos . ' 1.5" sizen="30 3 2" halign="right" scale="0.3" style="TextRaceChrono" text="$s$dd0'.formatTime($data['score']).'"/>'; 
				 }
				$xml .= '<format textsize="1"/><label posn="-21.5 ' . $linkmaniapos. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$0b0'.$fteam.' "/>';
				$xml .= '<format textsize="1"/><label posn="-17.3' . $linkmaniapos. ' 1.5" sizen="30 3 2" scale="0.3" style="TextRaceChrono" halign="center" text="$s$2f0'.$data['CPs'].' "/>';		
				$xml .= '<format textsize="1.7"/><label posn="-14.5 ' . $linkmaniapos . ' 1.6" sizen="12 3 2" halign="left" text="$s$fff' .$this->TeamNames[$data['team']]. ' "/>';
			  $xml .= '<quad sizen="6.8 3" posn="-27.4 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
			  $xml .= '<quad sizen="4 3" posn="-21.8 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton" />';
			  $xml .= '<quad sizen="4 3" posn="-17.6 ' . $maniapos . ' 1"  valign="center" halign="center" style="Bgs1InRace" substyle="NavButton"/>';
			  $xml .= '<quad sizen="17 3" posn="-15.4 ' . $maniapos . ' 1.1"  valign="center" halign="left" style="Bgs1InRace" substyle="NavButton"/>';
			}
		
		}

	$xml .= '</frame>';
	$xml .= '</manialink>';
	$this->Aseco->addCall('SendDisplayManialinkPage', array( $xml, 0, false));	

	}
	
function showGiveUp($login) {
$xml = '
<manialinks>
		<manialink id="17000">
<frame pos="0.25 0 0">
			<label halign="center" valign="center" pos="-0.125 0 -0.2" text = "$000'.T_("Give up").'" />
		 	<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgButton" pos="-0.125 0 -0.2" size="0.24 0.06" action="'.(10004).'" />			
			</frame>
			
			<frame pos="0 0 0">
			<label halign="center" valign="center" pos="-0.125 0 -0.2" text = "$000'.T_("Cancel").'" />
		 	<quad halign="center" valign="center" style="Bgs1InRace" substyle="BgButton" pos="-0.125 0 -0.2" size="0.24 0.06" action="'.(10005).'" />
			</frame>
			</manialink>
			</manialinks>';
$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));
}

function hideGiveUp($login) {
$xml = '<manialinks>
		<manialink id="17000">
		</manialink>
			</manialinks>';
$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));
$this->showPlayers();
}
		
	//
	// Helper Functions
	//
	//
	
	function GiveUp($login) {
	$slot = $this->getPlayerAttrByLogin($login, "login");
	$team = $this->getPlayerAttrByLogin($login,"Team"); //get team 	
	$this->TeamTime[$team]['temp'] = 0;
	
	$teams = $this->playerSearch("Team",$team);
					$tcount = 0;
						foreach ($teams as $data) {
						if ($data['enabled']) $tcount++;
						}	
								
						if ($tcount == 1) {
						
			
			$this->setPlayerAttrByLogin($login,"enabled",0);
			$inrace = $this->getPlayerAttrByLogin($login,"inRace"); // get inrace status
			$this->setPlayerAttrByLogin($login,"inRace",0);  // set player inactive
			$this->setSpectator($login,1);
			for ($x=count($this->finishedPlayers[$team]); $x < $this->Laps; $x++) {
			$this->finishedPlayers[$team][]++; 
			}
			$this->TeamTime[$team]['score'] = 999999999;
			$this->TeamDisq[$team] = 1;
			$this->hideGiveUp($login);
		} else 
		{
	
	
		$team = $this->getPlayerAttrByLogin($login,"Team");
		$this->setPlayerAttrByLogin($login,"enabled",0);
		$this->setPlayerAttrByLogin($login,"inRace",0);  // set player inactive
		$this->setPlayerAttrByLogin($login,"inStamp", 0);			
		$this->setSpectator($login,1);
		$nextLogin = $this->GetNextPlayerInTeam($team,$login);
		$this->setPlayerAttrByLogin($nextLogin,"inRace",1);
		$time = $this->getTime();
		$this->setPlayerAttrByLogin($nextLogin,"inStamp", $time);			
		$this->setSpectator($nextLogin,2);
		$this->hideGiveUp($login);
		}
		
	$this->showPlayers();	
	$this->checkGameEnd();	
	}
	
	function GetSlotPlayer($team, $place) {
		$players = $this->playerSearch("Team",$team);
		foreach ($players as $data) {
			if ( $data['Place'] == $place ) { return $data['login']; 
			break;
			}
		}		
		return false;
	}
	
	function GetNextPlayerInTeam($team, $login,$count = 0) {
      $place = $this->getPlayerAttrByLogin($login,'Place');
      if($place===false)
        $place=-1;
      for($i=0;$i<$this->TeamMaxPlayers;$i++) {
        $place++;
        if($place>=$this->TeamMaxPlayers) $place=0;
  		$player = $this->GetSlotPlayer($team,$place); // $place
  		if($player && $this->Players[$player]['enabled'] && !$this->Players[$player]['isSpec'])
           return $player;
      }
      return 0;
    }	
	
	function preloadAudio($login) {
		$xml = '<manialinks><manialink id="16000">
		<audio pos="1 1 0" play="0" looping="0">http://koti.mbnet.fi/reaby/tmn/relay/menu_select.ogg</audio>
		<audio pos="1 1 0" play="0" looping="0">http://koti.mbnet.fi/reaby/tmn/relay/menu_done.ogg</audio>
		</manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));	
	}

	function sendAudioSelect($login) {
		$xml = '<manialinks><manialink id="16000"><audio pos="1 1 0" play="1" looping="0">http://koti.mbnet.fi/reaby/tmn/relay/menu_select.ogg</audio></manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));	
	}

	function sendAudioDone($login) {
		$xml = '<manialinks><manialink id="16000"><audio pos="1 1 0" play="1" looping="0">http://koti.mbnet.fi/reaby/tmn/relay/menu_done.ogg</audio></manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));	
	}

	function resetCounters() {
		$this->Counters['selectEnvironment']['enabled'] = 0;
		$this->Counters['selectChallenge']['enabled'] = 0;
		$this->Counters['selectTeams']['enabled'] = 0;
		$this->Counters['showScoreboard']['enabled'] = 0;
		$this->Counters['showPoints']['enabled'] = 0;
		$this->Counters['selectEnvironment']['count'] = 0;
		$this->Counters['selectChallenge']['count'] = 0;
		$this->Counters['selectTeams']['count'] = 0;
		$this->Counters['showScoreboard']['count'] = 0;
		$this->Counters['showPoints']['count'] = 0;
		$this->Counters['finishTeam']['count'] = 0;
		$this->Counters['finishTeam']['enabled'] = 0;
		
	}
	function sendNextMsg($login) {
		$manialinkID= $this->manialinkID;
		$xml = '<manialinks><manialink id="'.($manialinkID).'"><update>0</update>';
		$xml .='<frame pos="-0.8 0 0"><format textsize="3" />';
		$xml .= '<label halign="top" valign="right" pos="0 0 0" text="$s$f00YOU ARE NEXT!" />';
		$xml .='</frame>';
		$xml .='</manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));	
	}

	function displayCounter($now,$total) {
		$xml = '<manialinks><manialink id="13000"><update>0</update>';
		$xml .='<frame pos="-0.8 0.4 0"><format textsize="5" />';
		$xml .= '<label halign="center" valign="center" style="TextRaceChrono" pos="0 0 0" text="$s$fff'.($total-$now).'" />';
		$xml .='</frame>';
		$xml .='</manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPage', array($xml, 0, false));	
	}


	function setSpectator($login,$mode) {
		$this->Aseco->addCall('ForceSpectator', array($login, $mode));	
	}	


	function MLresetAll() {
		foreach(	$this->Aseco->server->players->player_list as $pl) {
			$this->MLreset($pl->login);
		}
	}


	function MLreset($login) {
		$manialinkID= $this->manialinkID;
		$xml = '<manialinks><manialink id="9000"><update>0</update></manialink><manialink id="1"></manialink><manialink id="13000"></manialink><manialink id="14000"></manialink><manialink id="15000"></manialink><manialink id="17000"></manialink></manialinks>';
		$this->Aseco->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));	
	}

	function playerSearch($term,$search) {
		foreach($this->Players as $key => $data) {
			if ($data[$term] == $search) $return[] = $data;
		}
		if (empty($return)) return array();
		return ($return);
	}

	function getPlayerById($id) {
		foreach($this->Players as $data) {
			if ($data['Id'] == $id) return $data;
		}
		return false;
	}

	function setPlayerAttrByLogin($login,$attr,$value) {
		$this->Players[$login][$attr]=$value;
	}

	function getPlayerAttrByLogin($login,$attr) {
		if ( isset($this->Players[$login][$attr]) ) return $this->Players[$login][$attr] ;
		return false;

	}

	function getPlayerAttrBySlot($id,$attr) {
		$id = $this->playerSearch("Id",$id);
		if( !empty($id) ) {
			return $this->Players[$id[0]['login']][$attr];
		}
		return false;
	}


	function addSpectator($login) {
		$player = $this->Aseco->server->players->getPlayer($login);	
		$this->Players[$login] = array("Id" => -1, "Team" => -1, "Place" => -1, "nickname" => $player->nickname, "login" => $login, "enabled" => 1, "isSpec" => 1, "ready" => 0);
	}
	
	function addPlayer($login,$slot) {
		$player = $this->Aseco->server->players->getPlayer($login);	
	
		$slotCount = 0;	
		for ($i = 0; $i < $this->TeamCount; $i++) {
			for ($o = 0; $o < $this->TeamMaxPlayers; $o++) {
	
			if ($slotCount == $slot) {
				$this->Players[$login] = array("Id" => $slot, "Team" => $i, "Place" => $o, "nickname" => $player->nickname, "login" => $login, "enabled" => 1, "isSpec" => 0, "ready" => 0);
			} 
			$slotCount++;
			}
		}		
		
	}		

	function removePlayer($login) {
		unset($this->Players[$login]);
	}

	function allSpec() {
	global $relay, $aseco;
		foreach( $aseco->server->players->player_list as $pl) {
			$relay->setSpectator($pl->login,1);
		}
	}

	function allSpecOff() {
		global $relay, $aseco;
		foreach( $aseco->server->players->player_list as $pl) {
			$relay->setSpectator($pl->login,2);
		}
	}
	
	function allSpecFree() {
		global $relay, $aseco;
		foreach( $aseco->server->players->player_list as $pl) {
			$relay->setSpectator($pl->login,0);
		}
	}
	

	function getTime() {
	$time = microtime(true);
	$mtime = explode(".",$time);
	$sec = $mtime[0];
	$msec = substr($mtime[1],0,3);
	$output = $sec.$msec;
	if (strlen($output) < 13) {
		for ($x = strlen($output); $x < 13; $x++) {
			$output = $output."0";
		}
	}
	return $output;
	}
	
} //end of Class


function relay_sort_cp($a,$b) 
	{
		if($a["cps"]==$b["cps"]) return 0;
		return $a["cps"]<$b["cps"]?1:-1; 
	}
	
function relay_sort_pos($a,$b) 
	{
//		if($a["cps"]==$b["cps"]) return 0;
//		return $a["cps"]<$b["cps"]?1:-1; 

    if ($a["CPs"] > $b["CPs"]) {
        return -1;
    } elseif ($b["CPs"] > $a["CPs"]) {
        return 1;
    } else {
        if ($a["score"] > $b["score"]) {
            return 1;
        } elseif ($b["score"] > $a["score"]) {
            return -1;
        } else {
            return 0;
        }
    }
}

function shuffle_assoc(&$array) {
        $keys = array_keys($array);

        shuffle($keys);

        foreach($keys as $key) {
            $new[$key] = $array[$key];
        }

        $array = $new;

        return true;
}	

function removeBOM($str=""){
        if(substr($str, 0,3) == pack("CCC",0xef,0xbb,0xbf)) {
                $str=substr($str, 3);
        }
        return validateUTF8String($str);
}

function relay_debug($message) {
global $relay;
	if ( $relay->debug ) { 
		$relay->Aseco->client->query('ChatSendServerMessage', $message);
		print $message."\n";
	}
}
?>
